<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleMinimizeJointReaction.m</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleMinimizeJointReaction_8m-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleMinimizeJointReaction.m</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example of MocoJointReactionGoal.</p>
<div class="fragment"><div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% <a class="code" href="namespaceOpenSim.html">OpenSim</a> Moco: exampleMinimizeJointReaction.m                               %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% Copyright (c) 2017 Stanford University and the Authors                     %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Author(s): Nicholas Bianco                                                 %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    %</div>
<div class="line">% not use <span class="keyword">this</span> file except in compliance with the License. You may obtain a  %</div>
<div class="line">% copy of the License at http:<span class="comment">//www.apache.org/licenses/LICENSE-2.0          %</span></div>
<div class="line">%                                                                            %</div>
<div class="line">% Unless required by applicable law or agreed to in writing, software        %</div>
<div class="line">% distributed under the License is distributed on an <span class="stringliteral">&quot;AS IS&quot;</span> BASIS,          %</div>
<div class="line">% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   %</div>
<div class="line">% See the License <span class="keywordflow">for</span> the specific language governing permissions and        %</div>
<div class="line">% limitations under the License.                                             %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line"> </div>
<div class="line">function exampleMinimizeJointReaction()</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% Control effort minimization problem.</div>
<div class="line">% ====================================</div>
<div class="line">% This problem minimizes the squared control effort, integrated over the phase.</div>
<div class="line">effort = MocoControlGoal();</div>
<div class="line">runInvertedPendulumProblem(<span class="stringliteral">&#39;minimize_control_effort&#39;</span>, effort);</div>
<div class="line"> </div>
<div class="line">% Joint reaction load minimization problem.</div>
<div class="line">% =========================================</div>
<div class="line">% This problem minimizes the reaction loads on the rotating body at the pin </div>
<div class="line">% joint. Specifically, the norm of the reaction forces and moments integrated</div>
<div class="line">% over the phase is minimized.</div>
<div class="line">reaction = MocoJointReactionGoal();</div>
<div class="line">reaction.setJointPath(<span class="stringliteral">&#39;pin&#39;</span>);</div>
<div class="line">runInvertedPendulumProblem(<span class="stringliteral">&#39;minimize_joint_reaction_loads&#39;</span>, reaction);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line"><span class="keyword">function</span> solution = runInvertedPendulumProblem(name, goal)</div>
<div class="line"> </div>
<div class="line"><span class="keyword">import</span> org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% Create the inverted pendulum model.</div>
<div class="line">% ===================================</div>
<div class="line">model = createInvertedPendulumModel();</div>
<div class="line"> </div>
<div class="line">% Create MocoStudy.</div>
<div class="line">% ================</div>
<div class="line">study = MocoStudy();</div>
<div class="line">% The name of the study is used as part of the file name <span class="keywordflow">for</span> the solution.</div>
<div class="line">study.setName(name);</div>
<div class="line"> </div>
<div class="line">% Define the optimal control problem.</div>
<div class="line">% ===================================</div>
<div class="line">problem = study.updProblem();</div>
<div class="line"> </div>
<div class="line">% Model (dynamics).</div>
<div class="line">% -----------------</div>
<div class="line">problem.setModel(model);</div>
<div class="line"> </div>
<div class="line">% Bounds.</div>
<div class="line">% -------</div>
<div class="line">% Initial time must be zero, final time must be 1.</div>
<div class="line">problem.setTimeBounds(MocoInitialBounds(0), MocoFinalBounds(1));</div>
<div class="line"> </div>
<div class="line">% Initial position must be 0, <span class="keyword">final</span> position must be 180 degrees.</div>
<div class="line">problem.setStateInfo(<span class="stringliteral">&#39;/pin/angle/value&#39;</span>, MocoBounds(-10, 10), ...</div>
<div class="line">    MocoInitialBounds(0), MocoFinalBounds(pi));</div>
<div class="line">% Initial and <span class="keyword">final</span> speed must be 0. Use compact syntax.</div>
<div class="line">problem.setStateInfo(<span class="stringliteral">&#39;/pin/angle/speed&#39;</span>, [-50, 50], [0], [0]);</div>
<div class="line"> </div>
<div class="line">% Applied moment must be between -100 and 100 N-m.</div>
<div class="line">problem.setControlInfo(&#39;/forceset/actuator&#39;, MocoBounds(-100, 100));</div>
<div class="line"> </div>
<div class="line">% Goal.</div>
<div class="line">% -----</div>
<div class="line">problem.addGoal(goal);</div>
<div class="line"> </div>
<div class="line">% Configure the solver.</div>
<div class="line">% =====================</div>
<div class="line">solver = study.initCasADiSolver();</div>
<div class="line">solver.set_num_mesh_intervals(50);</div>
<div class="line">solver.set_optim_convergence_tolerance(1e-3);</div>
<div class="line"> </div>
<div class="line">% Now that we<span class="stringliteral">&#39;ve finished setting up the tool, print it to a file.</span></div>
<div class="line"><span class="stringliteral">study.print([name &#39;</span>.omoco<span class="stringliteral">&#39;]);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Solve the problem.</span></div>
<div class="line"><span class="stringliteral">% ==================</span></div>
<div class="line"><span class="stringliteral">solution = study.solve();</span></div>
<div class="line"><span class="stringliteral">solution.write([name &#39;</span>_solution.sto<span class="stringliteral">&#39;]);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Visualize.</span></div>
<div class="line"><span class="stringliteral">% ==========</span></div>
<div class="line"><span class="stringliteral">% The following environment variable is set during automated testing.</span></div>
<div class="line"><span class="stringliteral">if ~strcmp(getenv(&#39;</span>OPENSIM_USE_VISUALIZER<span class="stringliteral">&#39;), &#39;</span>0<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">    study.visualize(solution);</span></div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Plot results.</span></div>
<div class="line"><span class="stringliteral">% =============</span></div>
<div class="line"><span class="stringliteral">figure;</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Plot states trajectory solution.</span></div>
<div class="line"><span class="stringliteral">% --------------------------------</span></div>
<div class="line"><span class="stringliteral">subplot(3,1,1);</span></div>
<div class="line"><span class="stringliteral">time = solution.getTimeMat();</span></div>
<div class="line"><span class="stringliteral">plot(time, solution.getStatesTrajectoryMat())</span></div>
<div class="line"><span class="stringliteral">xlabel(&#39;</span>time (s)<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">ylabel(&#39;</span>states<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">legend(&#39;</span>pin/angle/value<span class="stringliteral">&#39;, &#39;</span>pin/angle/speed<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">title(strrep(name, &#39;</span>_<span class="stringliteral">&#39;, &#39;</span> <span class="stringliteral">&#39;))</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Plot controls trajectory solution.</span></div>
<div class="line"><span class="stringliteral">% ----------------------------------</span></div>
<div class="line"><span class="stringliteral">subplot(3,1,2)</span></div>
<div class="line"><span class="stringliteral">plot(time, solution.getControlsTrajectoryMat())</span></div>
<div class="line"><span class="stringliteral">xlabel(&#39;</span>time (s)<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">ylabel(&#39;</span>control<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">legend(&#39;</span>actuator<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Plot trajectory of the norm of the joint reaction loads.</span></div>
<div class="line"><span class="stringliteral">% --------------------------------------------------------</span></div>
<div class="line"><span class="stringliteral">statesTraj = solution.exportToStatesTrajectory(problem);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% This function adds the solution controls as prescribed controllers to the </span></div>
<div class="line"><span class="stringliteral">% model. This ensures that the correct reaction loads are computed when </span></div>
<div class="line"><span class="stringliteral">% realizing to acceleration.</span></div>
<div class="line"><span class="stringliteral">opensimMoco.prescribeControlsToModel(solution, model);</span></div>
<div class="line"><span class="stringliteral">model.initSystem();</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Compute reaction loads.</span></div>
<div class="line"><span class="stringliteral">jointReactionNorm = zeros(size(time));</span></div>
<div class="line"><span class="stringliteral">for i = 1:length(time)</span></div>
<div class="line"><span class="stringliteral">    state = statesTraj.get(i-1);</span></div>
<div class="line"><span class="stringliteral">    </span></div>
<div class="line"><span class="stringliteral">    % Need to realize to acceleration for the reaction loads.</span></div>
<div class="line"><span class="stringliteral">    model.realizeAcceleration(state);</span></div>
<div class="line"><span class="stringliteral">    joint = PinJoint().safeDownCast(model.getComponent(&#39;</span>pin<span class="stringliteral">&#39;));</span></div>
<div class="line"><span class="stringliteral">    reactionLoadsSpatialVec = ...</span></div>
<div class="line"><span class="stringliteral">        joint.calcReactionOnChildExpressedInGround(state);</span></div>
<div class="line"><span class="stringliteral">    </span></div>
<div class="line"><span class="stringliteral">    % Convert the reaction load SpatialVec to a usable format.</span></div>
<div class="line"><span class="stringliteral">    reactionLoadsFlat = flattenSpatialVec(reactionLoadsSpatialVec);</span></div>
<div class="line"><span class="stringliteral">    </span></div>
<div class="line"><span class="stringliteral">    % Compute the norm.</span></div>
<div class="line"><span class="stringliteral">    jointReactionNorm(i) = norm(reactionLoadsFlat);</span></div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">subplot(3,1,3);</span></div>
<div class="line"><span class="stringliteral">plot(time, jointReactionNorm)</span></div>
<div class="line"><span class="stringliteral">integralJointReactionNorm = trapz(time, jointReactionNorm)</span></div>
<div class="line"><span class="stringliteral">xlabel(&#39;</span>time (s)<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">ylabel(&#39;</span>norm reaction loads<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">function model = createInvertedPendulumModel()</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">import org.opensim.modeling.*;</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">model = Model();</span></div>
<div class="line"><span class="stringliteral">model.setName(&#39;</span>inverted_pendulum<span class="stringliteral">&#39;);</span></div>
<div class="line"><span class="stringliteral">body = Body(&#39;</span>body<span class="stringliteral">&#39;, 1.0, Vec3(0), Inertia(1));</span></div>
<div class="line"><span class="stringliteral">model.addComponent(body);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">joint = PinJoint(&#39;</span>pin<span class="stringliteral">&#39;, model.getGround(), Vec3(0), Vec3(0), ...</span></div>
<div class="line"><span class="stringliteral">                        body,              Vec3(-1, 0, 0), Vec3(0));</span></div>
<div class="line"><span class="stringliteral">coord = joint.updCoordinate();</span></div>
<div class="line"><span class="stringliteral">coord.setName(&#39;</span>angle<span class="stringliteral">&#39;);</span></div>
<div class="line"><span class="stringliteral">model.addComponent(joint);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">actu = CoordinateActuator();</span></div>
<div class="line"><span class="stringliteral">actu.setCoordinate(coord);</span></div>
<div class="line"><span class="stringliteral">actu.setName(&#39;</span>actuator<span class="stringliteral">&#39;);</span></div>
<div class="line"><span class="stringliteral">actu.setOptimalForce(1);</span></div>
<div class="line"><span class="stringliteral">model.addForce(actu);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">geom = Ellipsoid(0.5, 0.1, 0.1);</span></div>
<div class="line"><span class="stringliteral">transform = Transform(Vec3(-0.5, 0, 0));</span></div>
<div class="line"><span class="stringliteral">body_center = PhysicalOffsetFrame(&#39;</span>body_center<span class="stringliteral">&#39;, body, transform);</span></div>
<div class="line"><span class="stringliteral">body.addComponent(body_center);</span></div>
<div class="line"><span class="stringliteral">body_center.attachGeometry(geom);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">model.finalizeConnections();</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">function spatialVecFlat = flattenSpatialVec(spatialVec)</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">spatialVecFlat = zeros(6,1);</span></div>
<div class="line"><span class="stringliteral">spatialVecFlat(1) = spatialVec.get(0).get(0);</span></div>
<div class="line"><span class="stringliteral">spatialVecFlat(2) = spatialVec.get(0).get(1);</span></div>
<div class="line"><span class="stringliteral">spatialVecFlat(3) = spatialVec.get(0).get(2);</span></div>
<div class="line"><span class="stringliteral">spatialVecFlat(4) = spatialVec.get(1).get(0);</span></div>
<div class="line"><span class="stringliteral">spatialVecFlat(5) = spatialVec.get(1).get(1);</span></div>
<div class="line"><span class="stringliteral">spatialVecFlat(6) = spatialVec.get(1).get(2);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
